# HG changeset patch
# User Michael Godfrey <michaeldgodfrey@gmail.com>
# Date 1379807427 14400
#      Sat Sep 21 19:50:27 2013 -0400
# Node ID 75cc238c64cdcfd328c1a2f080613cda2ac27606
# Parent  a4f86f459744d1bea2a38c5931d3028d2b0909cb
update tex Table and symbol for o

diff -r a4f86f459744 -r 75cc238c64cd doc/interpreter/plot.txi
--- a/doc/interpreter/plot.txi	Sat Sep 21 08:30:34 2013 -0400
+++ b/doc/interpreter/plot.txi	Sat Sep 21 19:50:27 2013 -0400
@@ -406,7 +406,7 @@
 @subsubsection Aspect Ratio
 
 For three-dimensional plots the aspect ratio can be set for data with
-@code{daspect} and for the plot box with @code{pbaspect}.  
+@code{daspect} and for the plot box with @code{pbaspect}.
 @xref{Axis Configuration}, for controlling the x-, y-, and z-limits for
 plotting.
 
@@ -639,126 +639,177 @@
 @float Table,tab:extended
 @tex
 \vskip 6pt
-{\hbox to \hsize {\hfill\vbox{\offinterlineskip \tabskip=0pt
+\def\symtable#1#2#3{\hbox to \hsize {\hfill\vbox{\offinterlineskip \tabskip=0pt
+\hskip36pt #1
+\vskip6pt
 \halign{
-\vrule height2.0ex depth1.ex width 0.6pt #\tabskip=0.3em &
-# \hfil & \vrule # & # \hfil & # \vrule &
-# \hfil & \vrule # & # \hfil & # \vrule &
-# \hfil & \vrule # & # \hfil & # \vrule
+\vrule height2.0ex depth1.ex width 0.6pt #2\tabskip=0.3em &
+#2 \hfil & \vrule #2 & #2 \hfil & #2 \vrule &
+#2 \hfil & \vrule #2 & #2 \hfil & #2 \vrule &
+#2 \hfil & \vrule #2 & #2 \hfil & #2 \vrule
 width 0.6pt \tabskip=0pt\cr
 \noalign{\hrule height 0.6pt}
 & Code && Sym && Code && Sym && Code && Sym &\cr
 \noalign{\hrule}
-& $\backslash$forall    && $\forall$
-&& $\backslash$exists   && $\exists$
-&& $\backslash$ni       && $\ni$       &\cr
+#3
+\noalign{\hrule height 0.6pt}
+}
+}\hfill}}
+\symtable{Lower Case Greek Letters} {#}
+{& $\backslash$alpha     && $\alpha$
+&& $\backslash$beta      && $\beta$
+&& $\backslash$gamma     && $\gamma$     &\cr
+& $\backslash$delta      && $\delta$
+&& $\backslash$epsilon   && $\epsilon$
+&& $\backslash$zeta      && $\zeta$      &\cr
+& $\backslash$eta        && $\eta$
+&& $\backslash$theta     && $\theta$
+&& $\backslash$vartheta  && $\vartheta$  &\cr
+& $\backslash$iota       && $\iota$
+&& $\backslash$kappa     && $\kappa$
+&& $\backslash$lambda    && $\lambda$    &\cr
+& $\backslash$mu         && $\mu$
+&& $\backslash$nu        && $\nu$
+&& $\backslash$xi        && $\xi$        &\cr
+& $\backslash$o          && $o$
+&& $\backslash$pi        && $\pi$
+&& $\backslash$varpi     && $\varpi$     &\cr
+& $\backslash$rho        && $\rho$
+&& $\backslash$sigma     && $\sigma$
+&& $\backslash$varsigma  && $\varsigma$  &\cr
+& $\backslash$tau        && $\tau$
+&& $\backslash$upsilon   && $\upsilon$
+&& $\backslash$phi       && $\phi$       &\cr
+& $\backslash$chi        && $\chi$
+&& $\backslash$psi       && $\psi$
+&& $\backslash$omega     && $\omega$     &\cr}
+\vskip12pt
+\symtable{Greek Upper Case Letters} {#}
+{& $\backslash$Gamma   && $\Gamma$
+&& $\backslash$Delta   && $\Delta$
+&& $\backslash$Theta   && $\Theta$      &\cr
+& $\backslash$Lambda   && $\Lambda$
+&& $\backslash$Xi      && $\Xi$
+&& $\backslash$Pi      && $\Pi$         &\cr
+& $\backslash$Sigma    && $\Sigma$
+&& $\backslash$Upsilon && $\Upsilon$
+&& $\backslash$Phi     && $\Phi$        &\cr
+& $\backslash$Psi      && $\Psi$
+&& $\backslash$Omega   && $\Omega$
+&&    &&       &\cr}
+\vskip12pt
+\symtable{Misc Symbols Type Ord} {#}
+{& $\backslash$aleph       && $\aleph$
+&& $\backslash$wp          && $\wp$
+&& $\backslash$Re          && $\Re$          &\cr
+& $\backslash$Im           && $\Im$
+&& $\backslash$partial     && $\partial$
+&& $\backslash$infty       && $\infty$       &\cr
+& $\backslash$prime        && $\prime$
+&& $\backslash$nabla       && $\nabla$
+&& $\backslash$surd        && $\surd$        &\cr
+& $\backslash$angle        && $\angle$
+&& $\backslash$forall      && $\forall$
+&& $\backslash$exists      && $\exists$      &\cr
+& $\backslash$neg          && $\neg$
+&& $\backslash$clubsuit    && $\clubsuit$
+&& $\backslash$diamondsuit && $\diamondsuit$ &\cr
+& $\backslash$heartsuit    && $\heartsuit$
+&& $\backslash$spadesuit   && $\spadesuit$
+&&    &&       &\cr}
+\vskip12pt
+\symtable{``Large'' Operators} {#}
+{& $\backslash$int   && $\int$
+&&    &&
+&&    &&       &\cr}
+\vskip12pt
+\symtable{Binary operators} {#}
+{& $\backslash$pm     && $\pm$
+&& $\backslash$cdot   && $\cdot$
+&& $\backslash$times  && $\times$      &\cr
+& $\backslash$ast     && $\ast$
+&& $\backslash$circ   && $\circ$
+&& $\backslash$bullet && $\bullet$     &\cr
+& $\backslash$div     && $\div$
+&& $\backslash$cap    && $\cap$
+&& $\backslash$cup    && $\cup$        &\cr
+& $\backslash$vee     && $\vee$
+&& $\backslash$wedge  && $\wedge$
+&& $\backslash$oplus  && $\oplus$      &\cr
+& $\backslash$otimes  && $\otimes$
+&& $\backslash$oslash && $\oslash$
+&&    &&      &\cr}
+@end tex
+@caption{Available special characters in @TeX{} mode}
+@end float
+@float Table,tab2:extended
+@tex
+\vskip 6pt
+\def\symtable#1#2#3{\hbox to \hsize {\hfill\vbox{\offinterlineskip \tabskip=0pt
+\hskip36pt #1
+\vskip6pt
+\halign{
+\vrule height2.0ex depth1.ex width 0.6pt #2\tabskip=0.3em &
+#2 \hfil & \vrule #2 & #2 \hfil & #2 \vrule &
+#2 \hfil & \vrule #2 & #2 \hfil & #2 \vrule &
+#2 \hfil & \vrule #2 & #2 \hfil & #2 \vrule
+width 0.6pt \tabskip=0pt\cr
+\noalign{\hrule height 0.6pt}
+& Code && Sym && Code && Sym && Code && Sym &\cr
+\noalign{\hrule}
+#3
+\noalign{\hrule height 0.6pt}
+}
+}\hfill}}
+\vskip6pt
+\symtable{Relations} {#}
+{& $\backslash$leq      && $\leq$
+&& $\backslash$subset   && $\subset$
+&& $\backslash$subseteq && $\subseteq$    &\cr
+& $\backslash$in        && $\in$
+&& $\backslash$geq      && $\geq$
+&& $\backslash$supset   && $\supset$      &\cr
+& $\backslash$supseteq  && $\supseteq$
+&& $\backslash$ni       && $\ni$
+&& $\backslash$mid      && $\mid$         &\cr
+& $\backslash$equiv     && $\equiv$
+&& $\backslash$sim      && $\sim$
+&& $\backslash$approx   && $\approx$      &\cr
 & $\backslash$cong      && $\cong$
-&& $\backslash$Delta    && $\Delta$
-&& $\backslash$Phi      && $\Phi$      &\cr
-& $\backslash$Gamma     && $\Gamma$
-&& $\backslash$vartheta && $\vartheta$
-&& $\backslash$Lambda   && $\Lambda$   &\cr
-& $\backslash$Pi        && $\Pi$
-&& $\backslash$Theta    && $\Theta$
-&& $\backslash$Sigma    && $\Sigma$    &\cr
-& $\backslash$varsigma  && $\varsigma$
-&& $\backslash$Omega    && $\Omega$
-&& $\backslash$Xi       && $\Xi$       &\cr
-& $\backslash$Psi       && $\Psi$
-&& $\backslash$perp     && $\perp$
-&& $\backslash$alpha    && $\alpha$    &\cr
-& $\backslash$beta      && $\beta$
-&& $\backslash$chi      && $\chi$
-&& $\backslash$delta    && $\delta$    &\cr
-& $\backslash$epsilon   && $\epsilon$
-&& $\backslash$phi      && $\phi$
-&& $\backslash$gamma    && $\gamma$    &\cr
-& $\backslash$eta       && $\eta$
-&& $\backslash$iota     && $\iota$
-&& $\backslash$varphi   && $\varphi$   &\cr
-& $\backslash$kappa     && $\kappa$
-&& $\backslash$lambda   && $\lambda$
-&& $\backslash$mu       && $\mu$       &\cr
-& $\backslash$nu        && $\nu$
-&& $\backslash$o        && $\o$
-&& $\backslash$pi       && $\pi$       &\cr
-& $\backslash$theta     && $\theta$
-&& $\backslash$rho      && $\rho$
-&& $\backslash$sigma    && $\sigma$    &\cr
-& $\backslash$tau       && $\tau$
-&& $\backslash$upsilon  && $\upsilon$
-&& $\backslash$varpi    && $\varpi$    &\cr
-& $\backslash$omega     && $\omega$
-&& $\backslash$xi       && $\xi$
-&& $\backslash$psi      && $\psi$      &\cr
-& $\backslash$zeta      && $\zeta$
-&& $\backslash$sim      && $\sim$
-&& $\backslash$Upsilon  && $\Upsilon$  &\cr
-& $\backslash$prime     && $\prime$
-&& $\backslash$leq      && $\leq$
-&& $\backslash$infty    && $\infty$    &\cr
-& $\backslash$clubsuit  && $\clubsuit$
-&& $\backslash$diamondsuit    && $\diamondsuit$
-&& $\backslash$heartsuit      && $\heartsuit$     &\cr
-& $\backslash$spadesuit       && $\spadesuit$
+&& $\backslash$propto   && $\propto$
+&& $\backslash$perp     && $\perp$        &\cr}
+\vskip6pt
+\symtable{Arrows} {#}
+{& $\backslash$leftarrow      && $\leftarrow$
+&& $\backslash$Leftarrow      && $\Leftarrow$
+&& $\backslash$rightarrow     && $\rightarrow$      &\cr
+& $\backslash$Rightarrow      && $\Rightarrow$
 && $\backslash$leftrightarrow && $\leftrightarrow$
-&& $\backslash$leftarrow      && $\leftarrow$     &\cr
-& $\backslash$uparrow         && $\uparrow$
-&& $\backslash$rightarrow     && $\rightarrow$
-&& $\backslash$downarrow      && $\downarrow$     &\cr
-& $\backslash$circ      && $\circ$
-&& $\backslash$pm       && $\pm$
-&& $\backslash$geq      && $\geq$      &\cr
-& $\backslash$times     && $\times$
-&& $\backslash$propto   && $\propto$
-&& $\backslash$partial  && $\partial$  &\cr
-& $\backslash$bullet    && $\bullet$
-&& $\backslash$div      && $\div$
-&& $\backslash$neq      && $\neq$      &\cr
-& $\backslash$equiv     && $\equiv$
-&& $\backslash$approx   && $\approx$
-&& $\backslash$ldots    && $\ldots$ &\cr
-& $\backslash$mid       && $\mid$
-&& $\backslash$aleph    && $\aleph$
-&& $\backslash$Im       && $\Im$ &\cr
-& $\backslash$Re        && $\Re$
-&& $\backslash$wp       && $\wp$
-&& $\backslash$otimes   && $\otimes$ &\cr
-& $\backslash$oplus     && $\oplus$
-&& $\backslash$oslash   && $\oslash$
-&& $\backslash$cap      && $\cap$ &\cr
-& $\backslash$cup       && $\cup$
-&& $\backslash$supset   && $\supset$
-&& $\backslash$supseteq && $\supseteq$ &\cr
-& $\backslash$subset    && $\subset$
-&& $\backslash$subseteq && $\subseteq$
-&& $\backslash$in       && $\in$ &\cr
-& $\backslash$notin     && $\notin$
-&& $\backslash$angle    && $\angle$
-&& $\backslash$bigtriangledown && $\bigtriangledown$ &\cr
-& $\backslash$langle    && $\langle$
+&& $\backslash$uparrow        && $\uparrow$         &\cr
+& $\backslash$downarrow       && $\downarrow$
+&&   && 
+&&   &&       &\cr}
+\vskip12pt
+\symtable{Openings and Closings} {#}
+{& $\backslash$lfloor   && $\lfloor$
+&& $\backslash$langle   && $\langle$
+&& $\backslash$lceil    && $\lceil$      &\cr
+& $\backslash$rfloor    && $\rfloor$
 && $\backslash$rangle   && $\rangle$
-&& $\backslash$nabla    && $\nabla$    &\cr
-& $\backslash$prod      && $\prod$
-&& $\backslash$surd     && $\surd$
-&& $\backslash$cdot     && $\cdot$     &\cr
-& $\backslash$neg       && $\neg$
-&& $\backslash$wedge    && $\wedge$
-&& $\backslash$vee      && $\vee$      &\cr
-& $\backslash$Leftrightarrow && $\Leftrightarrow$
-&& $\backslash$Leftarrow     && $\Leftarrow$
-&& $\backslash$Uparrow       && $\Uparrow$           &\cr
-& $\backslash$Rightarrow     && $\Rightarrow$
-&& $\backslash$Downarrow     && $\Downarrow$
-&& $\backslash$diamond  && $\diamond$  &\cr
-& $\backslash$copyright && $\copyright$
-&& $\backslash$rfloor   && $\rfloor$
-&& $\backslash$lceil    && $\lceil$    &\cr
-& $\backslash$lfloor    && $\lfloor$
-&& $\backslash$rceil    && $\rceil$
-&& $\backslash$int      && $\int$      &\cr
-\noalign{\hrule height 0.6pt}
-}}\hfill}}
+&& $\backslash$rceil    && $\rceil$      &\cr}
+\vskip12pt
+\symtable{Alternate Names} {#}
+{& $\backslash$neq   && $\neq$
+&&   && 
+&&   &&   &\cr}
+\vskip12pt
+\symtable{Other (not in Appendix F Tables)} {#}
+{& $\backslash$ldots     && $\ldots$
+&& $\backslash$0         && $\oslash$
+&& $\backslash$copyright && $\copyright$      &\cr
+& $\backslash$deg        && $\deg$
+&&    &&  
+&&    &&       &\cr}
 @end tex
 @ifnottex
 @multitable @columnfractions .125 .25 .25 .25 .125
@@ -936,8 +987,8 @@
 
 Graphics handles may be distinguished from function handles
 (@pxref{Function Handles}) by means of the function @code{ishandle}.
-@code{ishandle} returns true if its argument is a handle of a graphics object. 
-In addition, the figure object may be tested using @code{isfigure}. 
+@code{ishandle} returns true if its argument is a handle of a graphics object.
+In addition, the figure object may be tested using @code{isfigure}.
 @code{isfigure} returns true only if its argument is a handle of a figure.  The
 @code{whos} function can be used to show the object type of each currently
 defined graphics handle.  (Note: this is not true today, but it is, I hope,
@@ -1180,9 +1231,9 @@
 Figures can be printed or saved in many graphics formats with @code{print} and
 @code{saveas}.  Occasionally, however, it may be useful to save the original
 Octave handle graphic directly so that further modifications can be made such
-as modifying a title or legend.  
-
-This can be accomplished with the following functions by 
+as modifying a title or legend.
+
+This can be accomplished with the following functions by
 
 @example
 @group
@@ -1226,12 +1277,12 @@
 The @code{root figure} properties are:
 
 @table @code
-@item __modified__  
+@item __modified__
 --- Values: @qcode{"on"}, @qcode{"off"}
 
 @item __myhandle__
 
-@item beingdeleted  
+@item beingdeleted
 --- Values: @qcode{"on"}, @qcode{"off"}
 
 @item busyaction
@@ -1251,13 +1302,13 @@
 
 @item deletefcn
 
-@item handlevisibility  
+@item handlevisibility
 --- Values: @qcode{"on"}, @qcode{"off"}
 
 @item hittest
 --- Values: @qcode{"on"}, @qcode{"off"}
 
-@item interruptible  
+@item interruptible
 --- Values: @qcode{"on"}, @qcode{"off"}
 
 @item parent
@@ -1276,7 +1327,7 @@
 
 @item screenpixelsperinch
 
-@item showhiddenhandles  
+@item showhiddenhandles
 --- Values: @qcode{"on"}, @qcode{"off"}
 
 @item tag
@@ -1299,7 +1350,7 @@
 The @code{figure} properties are:
 
 @table @code
-@item __graphics_toolkit__  
+@item __graphics_toolkit__
 --- The graphics toolkit currently in use.
 
 @item __enhanced__
@@ -1312,7 +1363,7 @@
 
 @item alphamap
 
-@item beingdeleted 
+@item beingdeleted
 --- Values: @qcode{"on"}, @qcode{"off"}
 
 @item busyaction
@@ -1325,7 +1376,7 @@
 @item clipping
 --- Values: @qcode{"on"}, @qcode{"off"}
 
-@item closerequestfcn 
+@item closerequestfcn
 --- Handle of function to call on close.
 
 @item color
@@ -1337,7 +1388,7 @@
 
 @item createfcn
 
-@item currentaxes 
+@item currentaxes
 Handle to graphics object of current axes.
 
 @item currentcharacter
@@ -1352,22 +1403,22 @@
 
 @item deletefcn
 
-@item dockcontrols 
+@item dockcontrols
 --- Values: @qcode{"on"}, @qcode{"off"}
 
-@item doublebuffer 
+@item doublebuffer
 --- Values: @qcode{"on"}, @qcode{"off"}
 
 @item filename
 
-@item handlevisibility 
+@item handlevisibility
 --- Values: @qcode{"on"}, @qcode{"off"}
 
 @item hittest
 
 @item integerhandle
 
-@item interruptible 
+@item interruptible
 --- Values: @qcode{"on"}, @qcode{"off"}
 
 @item inverthardcopy
@@ -1448,7 +1499,7 @@
 
 @item selected
 
-@item selectionhighlight 
+@item selectionhighlight
 --- Values: @qcode{"on"}, @qcode{"off"}
 
 @item selectiontype
@@ -1516,7 +1567,7 @@
 @item beingdeleted
 
 @item box
-Box surrounding axes. 
+Box surrounding axes.
 --- Values: @qcode{"on"}, @qcode{"off"}
 
 @item busyaction
@@ -1572,7 +1623,7 @@
 @code{dataaspectratio} also forces the @code{dataaspectratiomode}
 property to be set to @qcode{"manual"}.
 
-@item dataaspectratiomode 
+@item dataaspectratiomode
 Either @qcode{"manual"} or @qcode{"auto"}.
 
 @item deletefcn
@@ -1685,7 +1736,7 @@
 
 @item x_viewtransform
 
-@item xaxislocation 
+@item xaxislocation
 Either @qcode{"top"} or @qcode{"bottom"}.
 
 @item xcolor
@@ -1707,7 +1758,7 @@
 @item xlimmode
 Either @qcode{"manual"} or @qcode{"auto"}.
 
-@item xminorgrid 
+@item xminorgrid
 Either @qcode{"on"} or @qcode{"off"} to toggle display of minor grid lines.
 
 @item xminortick
@@ -1724,13 +1775,13 @@
 Setting this property also forces the corresponding mode
 property to be set to @qcode{"manual"}.
 
-@item xticklabelmode 
+@item xticklabelmode
 Either @qcode{"manual"} or @qcode{"auto"}.
 
-@item xtickmode 
+@item xtickmode
 Either @qcode{"manual"} or @qcode{"auto"}.
 
-@item yaxislocation 
+@item yaxislocation
 Either @qcode{"left"} or @qcode{"right"}
 
 @item ycolor
@@ -1752,7 +1803,7 @@
 @item ylimmode
 Either @qcode{"manual"} or @qcode{"auto"}.
 
-@item yminorgrid 
+@item yminorgrid
 Either @qcode{"on"} or @qcode{"off"} to toggle display of minor grid lines.
 
 @item yminortick
@@ -1769,10 +1820,10 @@
 Setting this property also forces the corresponding mode
 property to be set to @qcode{"manual"}.
 
-@item yticklabelmode 
+@item yticklabelmode
 Either @qcode{"manual"} or @qcode{"auto"}.
 
-@item ytickmode 
+@item ytickmode
 Either @qcode{"manual"} or @qcode{"auto"}.
 
 @item zcolor
@@ -1794,7 +1845,7 @@
 @item zlimmode
 Either @qcode{"manual"} or @qcode{"auto"}.
 
-@item zminorgrid 
+@item zminorgrid
 Either @qcode{"on"} or @qcode{"off"} to toggle display of minor grid lines.
 
 @item zminortick
@@ -1807,11 +1858,11 @@
 Setting this property also forces the corresponding mode
 property to be set to @qcode{"manual"}.
 
-@item zticklabel 
+@item zticklabel
 Setting this property also forces the corresponding mode
 property to be set to @qcode{"manual"}.
 
-@item zticklabelmode 
+@item zticklabelmode
 Either @qcode{"manual"} or @qcode{"auto"}.
 
 @item ztickmode
@@ -2876,7 +2927,7 @@
 
 @item  edgecolor
 @itemx facecolor
-The line and fill color of the patch objects making up the areas. 
+The line and fill color of the patch objects making up the areas.
 @xref{Colors}.
 
 @item  xdata
@@ -3035,7 +3086,7 @@
 
 @table @code
 @item color
-The RGB color or color name of the line objects of the error bars. 
+The RGB color or color name of the line objects of the error bars.
 @xref{Colors}.
 
 @item  linewidth
@@ -3294,7 +3345,7 @@
 @item edgecolor
 
 @item facecolor
-The RGB color or color name of the edges or faces of the surface. 
+The RGB color or color name of the edges or faces of the surface.
 @xref{Colors}.
 
 @item  linewidth
diff -r a4f86f459744 -r 75cc238c64cd libinterp/corefcn/oct-tex-symbols.in
--- a/libinterp/corefcn/oct-tex-symbols.in	Sat Sep 21 08:30:34 2013 -0400
+++ b/libinterp/corefcn/oct-tex-symbols.in	Sat Sep 21 19:50:27 2013 -0400
@@ -3,10 +3,12 @@
 # - symbol name
 # - Unicode code
 # - MS symbol code (http://www.kostis.net/charsets/symbol.htm)
+# - Arranged by listings in The TeXbook, Appendix F 
+# - Lowercase Greek letters: Greek Upper case: Misc Symbols type Ord: "Large" operators:
+# - Binary operators: Relations: Negated relations: Arrows: Openings: Closings: Alternate names:
+# - Other (not in Appendix F Tables):
 
 alpha           0x03B1  0xF061
-angle           0x2220  0xF0D0
-ast             0x2217  0xF02A
 beta            0x03B2  0xF062
 gamma           0x03B3  0xF067
 delta           0x03B4  0xF064
@@ -21,25 +23,13 @@
 mu              0x03BC  0xF06D
 nu              0x03BD  0xF06E
 xi              0x03BE  0xF078
+o               0x03BF  0xF0B0
 pi              0x03C0  0xF070
+varpi           0x03D6  0xF076
 rho             0x03C1  0xF072
 sigma           0x03C3  0xF073
 varsigma        0x03C2  0xF056
 tau             0x03C4  0xF074
-equiv           0x2261  0xF0BA
-Im              0x2111  0xF0C1
-otimes          0x2297  0xF0C4
-cap             0x2229  0xF0C7
-supset          0x2283  0xF0C9
-int             0x222B  0xF0F2
-rfloor          0x230B  0xF0FB
-lfloor          0x230A  0xF0EB
-perp            0x22A5  0xF05E
-wedge           0x2227  0xF0D9
-rceil           0x2309  0xF0F9
-vee             0x2228  0xF0DA
-langle          0x27E8  0xF0E1
-
 upsilon         0x03C5  0xF075
 phi             0x03C6  0xF066
 chi             0x03C7  0xF063
@@ -56,57 +46,68 @@
 Phi             0x03A6  0xF046
 Psi             0x03A8  0xF059
 Omega           0x03A9  0xF057
+aleph           0x2135  0xF0C0
+wp              0x2118  0xF0C3
+Re              0x211C  0xF0C2
+Im              0x2111  0xF0C1
+partial         0x2202  0xF0B6
+infty           0x221E  0xF0A5
+prime           0x2032  0xF0A2
+nabla           0x2207  0xF0D1
+surd            0x221A  0xF0D6
+angle           0x2220  0xF0D0
 forall          0x2200  0xF022
 exists          0x2203  0xF024
-ni              0x220B  0xF027
-cong            0x2245  0xF040
-approx          0x2248  0xF0BB
-Re              0x211C  0xF0C2
-oplus           0x2295  0xF0C5
-cup             0x222A  0xF0C8
-subseteq        0x2286  0xF0CD
-in              0x2208  0xF0CE
-lceil           0x2308  0xF0E9
-cdot            0x22C5  0xF0D7
 neg             0x00AC  0xF0D8
-times           0x00D7  0xF0B4
-surd            0x221A  0xF0D6
-varpi           0x03D6  0xF076
-rangle          0x27E9  0xF0F1
-
-sim             0x223C  0xF07E
-leq             0x2264  0xF0A3
-infty           0x221E  0xF0A5
 clubsuit        0x2663  0xF0A7
 diamondsuit     0x2666  0xF0A8
 heartsuit       0x2665  0xF0A9
 spadesuit       0x2660  0xF0AA
-leftrightarrow  0x2194  0xF0AB
+int             0x222B  0xF0F2
+pm              0x00B1  0xF0B1
+cdot            0x22C5  0xF0D7
+times           0x00D7  0xF0B4
+ast             0x2217  0xF02A
+circ            0x2218  0xF0B0
+bullet          0x2219  0xF0B7
+div             0x00F7  0xF0B8
+cap             0x2229  0xF0C7
+cup             0x222A  0xF0C8
+vee             0x2228  0xF0DA
+wedge           0x2227  0xF0D9
+oplus           0x2295  0xF0C5
+otimes          0x2297  0xF0C4
+oslash          0x2298  0xF0C6
+leq             0x2264  0xF0A3
+subset          0x2282  0xF0CC
+subseteq        0x2286  0xF0CD
+in              0x2208  0xF0CE
+geq             0x2265  0xF0B3
+supset          0x2283  0xF0C9
+supseteq        0x2287  0xF0CA
+ni              0x220B  0xF027
+mid             0x2223  0xF0BD
+equiv           0x2261  0xF0BA
+sim             0x223C  0xF07E
+approx          0x2248  0xF0BB
+cong            0x2245  0xF040
+propto          0x221D  0xF0B5
+perp            0x22A5  0xF05E
 leftarrow       0x2190  0xF0AC
 Leftarrow       0x21D0  0xF0DC
-uparrow         0x2191  0xF0AD
 rightarrow      0x2192  0xF0AE
 Rightarrow      0x21D2  0xF0DE
+leftrightarrow  0x2194  0xF0AB
+uparrow         0x2191  0xF0AD
 downarrow       0x2193  0xF0AF
-circ            0x2218  0xF0B0
-pm              0x00B1  0xF0B1
-geq             0x2265  0xF0B3
-propto          0x221D  0xF0B5
-partial         0x2202  0xF0B6
-bullet          0x2219  0xF0B7
-div             0x00F7  0xF0B8
+lfloor          0x230A  0xF0EB
+langle          0x27E8  0xF0E1
+lceil           0x2308  0xF0E9
+rfloor          0x230B  0xF0FB
+rangle          0x27E9  0xF0F1
+rceil           0x2309  0xF0F9
 neq             0x2260  0xF0B9
-aleph           0x2135  0xF0C0
-wp              0x2118  0xF0C3
-oslash          0x2298  0xF0C6
-supseteq        0x2287  0xF0CA
-subset          0x2282  0xF0CC
-o               0x03BF  0xF0B0
-nabla           0x2207  0xF0D1
 ldots           0x2026  0xF0BC
-prime           0x2032  0xF0A2
-0               0x2205  0xF0C6
-mid             0x2223  0xF0BD
+0               0x2298  0xF0C6
 copyright       0x00A9  0xF0E3
-
 deg             0x00B0  0xF0B0